diff --git a/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js b/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
index 0cb80fe18..4fccec388 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/static/js/database.js
@@ -279,7 +279,7 @@ define('pgadmin.node.database', [
             t = pgBrowser.tree,
             i = input.item || t.selected(),
             d = i ? t.itemData(i) : undefined;
-          pgBrowser.erd.showErdTool(d, i, true);
+          pgAdmin.Tools.ERD.showErdTool(d, i, true);
         },
 
         /* Connect the database (if not connected), before opening this node */
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmSaveContent.jsx b/web/pgadmin/static/js/Dialogs/ConfirmSaveContent.jsx
similarity index 89%
rename from web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmSaveContent.jsx
rename to web/pgadmin/static/js/Dialogs/ConfirmSaveContent.jsx
index ef48b8c30..2838c6bec 100644
--- a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmSaveContent.jsx
+++ b/web/pgadmin/static/js/Dialogs/ConfirmSaveContent.jsx
@@ -1,8 +1,8 @@
 import React from 'react';
-import { useModalStyles } from '../../../../../../static/js/helpers/ModalProvider';
+import { useModalStyles } from '../helpers/ModalProvider';
 import gettext from 'sources/gettext';
 import { Box } from '@material-ui/core';
-import { DefaultButton, PrimaryButton } from '../../../../../../static/js/components/Buttons';
+import { DefaultButton, PrimaryButton } from '../components/Buttons';
 import CloseIcon from '@material-ui/icons/CloseRounded';
 import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
 import DeleteRoundedIcon from '@material-ui/icons/DeleteRounded';
diff --git a/web/pgadmin/static/js/SchemaView/DataGridView.jsx b/web/pgadmin/static/js/SchemaView/DataGridView.jsx
index 8d13115fe..b377544c9 100644
--- a/web/pgadmin/static/js/SchemaView/DataGridView.jsx
+++ b/web/pgadmin/static/js/SchemaView/DataGridView.jsx
@@ -508,7 +508,7 @@ export default function DataGridView({
             setGlobalFilter(value || undefined);
           }}
         />}
-        <div {...getTableProps()} className={classes.table}>
+        <div {...getTableProps(()=>({style: {minWidth: 'unset'}}))} className={classes.table}>
           <DataTableHeader headerGroups={headerGroups} />
           <div {...getTableBodyProps()} className={classes.tableContentWidth}>
             {rows.map((row, i) => {
diff --git a/web/pgadmin/static/js/Theme/dark.js b/web/pgadmin/static/js/Theme/dark.js
index 506434ad6..e36072a6e 100644
--- a/web/pgadmin/static/js/Theme/dark.js
+++ b/web/pgadmin/static/js/Theme/dark.js
@@ -100,7 +100,9 @@ export default function(basicSettings) {
       cardHeaderBg: '#424242',
       colorFg: '#FFFFFF',
       emptySpaceBg: '#212121',
-      textMuted: '#8A8A8A'
+      textMuted: '#8A8A8A',
+      erdCanvasBg: '#303030',
+      erdGridColor: '#444952',
     }
   });
 }
diff --git a/web/pgadmin/static/js/Theme/high_contrast.js b/web/pgadmin/static/js/Theme/high_contrast.js
index 4fbd6c0ca..9c8757370 100644
--- a/web/pgadmin/static/js/Theme/high_contrast.js
+++ b/web/pgadmin/static/js/Theme/high_contrast.js
@@ -98,7 +98,9 @@ export default function(basicSettings) {
       cardHeaderBg: '#062F57',
       colorFg: '#FFFFFF',
       emptySpaceBg: '#010B15',
-      textMuted: '#8b9cad'
+      textMuted: '#8b9cad',
+      erdCanvasBg: '#010B15',
+      erdGridColor: '#1F2932',
     }
   });
 }
diff --git a/web/pgadmin/static/js/Theme/standard.js b/web/pgadmin/static/js/Theme/standard.js
index ddceb8b80..66e24ee3f 100644
--- a/web/pgadmin/static/js/Theme/standard.js
+++ b/web/pgadmin/static/js/Theme/standard.js
@@ -106,6 +106,8 @@ export default function(basicSettings) {
       cardHeaderBg: '#fff',
       emptySpaceBg: '#ebeef3',
       textMuted: '#646B82',
+      erdCanvasBg: '#fff',
+      erdGridColor: '#bac1cd',
       explain: {
         sev2: {
           color: '#222222',
diff --git a/web/pgadmin/static/js/components/ExternalIcon.jsx b/web/pgadmin/static/js/components/ExternalIcon.jsx
index b5c0fee90..94d0b4603 100644
--- a/web/pgadmin/static/js/components/ExternalIcon.jsx
+++ b/web/pgadmin/static/js/components/ExternalIcon.jsx
@@ -17,6 +17,8 @@ import Collapse from '../../img/fonticon/close_fullscreen.svg?svgr';
 import AWS from '../../img/aws.svg?svgr';
 import BigAnimal from '../../img/biganimal.svg?svgr';
 import Azure from '../../img/azure.svg?svgr';
+import SQLFileSvg from '../../img/sql_file.svg?svgr';
+import MagicSvg from '../../img/magic.svg?svgr';
 
 export default function ExternalIcon({Icon, ...props}) {
   return <Icon className={'MuiSvgIcon-root'} {...props} />;
@@ -75,4 +77,10 @@ export const BigAnimalIcon = ({style})=><ExternalIcon Icon={BigAnimal} style={{h
 BigAnimalIcon.propTypes = {style: PropTypes.object};
 
 export const AzureIcon = ({style})=><ExternalIcon Icon={Azure} style={{height: '1.4rem', ...style}} data-label="AzureIcon" />;
-AzureIcon.propTypes = {style: PropTypes.object};
\ No newline at end of file
+AzureIcon.propTypes = {style: PropTypes.object};
+
+export const SQLFileIcon = ({style})=><ExternalIcon Icon={SQLFileSvg} style={{height: '1rem', ...style}} data-label="SQLFileIcon" />;
+SQLFileIcon.propTypes = {style: PropTypes.object};
+
+export const MagicIcon = ({style})=><ExternalIcon Icon={MagicSvg} style={{height: '1rem', ...style}} data-label="MagicIcon" />;
+MagicIcon.propTypes = {style: PropTypes.object};
diff --git a/web/pgadmin/static/js/components/Loader.jsx b/web/pgadmin/static/js/components/Loader.jsx
index 0232090be..48dd7f958 100644
--- a/web/pgadmin/static/js/components/Loader.jsx
+++ b/web/pgadmin/static/js/components/Loader.jsx
@@ -40,7 +40,7 @@ const useStyles = makeStyles((theme)=>({
   }
 }));
 
-export default function Loader({message, style, ...props}) {
+export default function Loader({message, style, autoEllipsis=false, ...props}) {
   const classes = useStyles();
   if(!message) {
     return <></>;
@@ -49,7 +49,7 @@ export default function Loader({message, style, ...props}) {
     <Box className={classes.root} style={style} data-label="loader" {...props}>
       <Box className={classes.loaderRoot}>
         <CircularProgress className={classes.loader} />
-        <Typography className={classes.message}>{message}</Typography>
+        <Typography className={classes.message}>{message}{autoEllipsis ? '...':''}</Typography>
       </Box>
     </Box>
   );
@@ -58,4 +58,5 @@ export default function Loader({message, style, ...props}) {
 Loader.propTypes = {
   message: PropTypes.string,
   style: PropTypes.oneOfType([PropTypes.object, PropTypes.array]),
+  autoEllipsis: PropTypes.bool,
 };
diff --git a/web/pgadmin/static/js/helpers/ModalProvider.jsx b/web/pgadmin/static/js/helpers/ModalProvider.jsx
index b7b9ee867..be18ded0d 100644
--- a/web/pgadmin/static/js/helpers/ModalProvider.jsx
+++ b/web/pgadmin/static/js/helpers/ModalProvider.jsx
@@ -98,7 +98,7 @@ export default function ModalProvider({ children }) {
   const [modals, setModals] = React.useState([]);
 
   const showModal = (title, content, modalOptions) => {
-    let id = getEpoch().toString() + crypto.getRandomValues(new Uint8Array(1));
+    let id = getEpoch().toString() + crypto.getRandomValues(new Uint8Array(4));
     setModals((prev) => [...prev, {
       id: id,
       title: title,
diff --git a/web/pgadmin/tools/erd/__init__.py b/web/pgadmin/tools/erd/__init__.py
index b1be8233e..5052fb544 100644
--- a/web/pgadmin/tools/erd/__init__.py
+++ b/web/pgadmin/tools/erd/__init__.py
@@ -399,8 +399,6 @@ def panel(trans_id):
     if 'gen' in params:
         params['gen'] = True if params['gen'] == 'true' else False
 
-    close_url = request.form['close_url']
-
     # We need client OS information to render correct Keyboard shortcuts
     user_agent = UserAgent(request.headers.get('User-Agent'))
 
@@ -439,7 +437,6 @@ def panel(trans_id):
     return render_template(
         "erd/index.html",
         title=underscore_unescape(params['title']),
-        close_url=close_url,
         requirejs=True,
         basejs=True,
         params=json.dumps(params),
diff --git a/web/pgadmin/tools/erd/static/js/ERDModule.js b/web/pgadmin/tools/erd/static/js/ERDModule.js
new file mode 100644
index 000000000..59549feff
--- /dev/null
+++ b/web/pgadmin/tools/erd/static/js/ERDModule.js
@@ -0,0 +1,255 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import pgWindow from 'sources/window';
+import {getPanelTitle} from 'tools/sqleditor/static/js/sqleditor_title';
+import {getRandomInt, registerDetachEvent} from 'sources/utils';
+import Notify from '../../../../static/js/helpers/Notifier';
+import url_for from 'sources/url_for';
+import gettext from 'sources/gettext';
+import React from 'react';
+import ReactDOM from 'react-dom';
+import ERDTool from './erd_tool/components/ERDTool';
+import ModalProvider from '../../../../static/js/helpers/ModalProvider';
+import Theme from '../../../../static/js/Theme';
+import $ from 'jquery';
+
+const wcDocker = window.wcDocker;
+
+export function setPanelTitle(erdToolPanel, panelTitle) {
+  erdToolPanel?.title('<span title="'+panelTitle+'">'+panelTitle+'</span>');
+}
+export default class ERDModule {
+  static instance;
+
+  static getInstance(...args) {
+    if(!ERDModule.instance) {
+      ERDModule.instance = new ERDModule(...args);
+    }
+    return ERDModule.instance;
+  }
+
+  constructor(pgAdmin, pgBrowser) {
+    this.pgAdmin = pgAdmin;
+    this.pgBrowser = pgBrowser;
+  }
+
+
+  init() {
+    if (this.initialized)
+      return;
+
+    this.initialized = true;
+
+    // Define the nodes on which the menus to be appear
+    this.pgBrowser.add_menus([{
+      name: 'erd',
+      module: this,
+      applies: ['tools'],
+      callback: 'showErdTool',
+      priority: 1,
+      label: gettext('ERD Tool'),
+      enable: this.erdToolEnabled,
+      data: {
+        data_disabled: gettext('The selected tree node does not support this option.'),
+      },
+    }]);
+
+    // let self = this;
+    // /* Cache may take time to load for the first time
+    //  * Keep trying till available
+    //  */
+    // let cacheIntervalId = setInterval(function() {
+    //   if(this.pgBrowser.preference_version() > 0) {
+    //     self.preferences = this.pgBrowser.get_preferences_for_module('erd');
+    //     clearInterval(cacheIntervalId);
+    //   }
+    // },0);
+
+    // this.pgBrowser.onPreferencesChange('erd', function() {
+    //   self.preferences = this.pgBrowser.get_preferences_for_module('erd');
+    // });
+
+    // Creating a new this.pgBrowser frame to show the data.
+    const erdFrameType = new this.pgBrowser.Frame({
+      name: 'frm_erdtool',
+      showTitle: true,
+      isCloseable: true,
+      isPrivate: true,
+      url: 'about:blank',
+    });
+
+    // Load the newly created frame
+    erdFrameType.load(this.pgBrowser.docker);
+    return this;
+  }
+
+  erdToolEnabled(obj) {
+    /* Same as query tool */
+    return (() => {
+      if (!_.isUndefined(obj) && !_.isNull(obj)) {
+        if (_.indexOf(this.pgAdmin.unsupported_nodes, obj._type) == -1) {
+          if (obj._type == 'database' && obj.allowConn) {
+            return true;
+          } else if (obj._type != 'database') {
+            return true;
+          } else {
+            return false;
+          }
+        } else {
+          return false;
+        }
+      } else {
+        return false;
+      }
+    })();
+  }
+
+  // Callback to draw ERD Tool for objects
+  showErdTool(_data, treeIdentifier, gen=false) {
+    if (treeIdentifier === undefined) {
+      Notify.alert(
+        gettext('ERD Error'),
+        gettext('No object selected.')
+      );
+      return;
+    }
+
+    const parentData = this.pgBrowser.tree.getTreeNodeHierarchy(treeIdentifier);
+
+    if(_.isUndefined(parentData.database)) {
+      Notify.alert(
+        gettext('ERD Error'),
+        gettext('Please select a database/database object.')
+      );
+      return;
+    }
+
+    const transId = getRandomInt(1, 9999999);
+    const panelTitle = getPanelTitle(this.pgBrowser, treeIdentifier);
+    const panelUrl = this.getPanelUrl(transId, parentData, gen);
+
+    let erdToolForm = `
+      <form id="erdToolForm" action="${panelUrl}" method="post">
+        <input id="title" name="title" hidden />
+      </form>
+      <script>
+        document.getElementById("title").value = "${_.escape(panelTitle)}";
+        document.getElementById("erdToolForm").submit();
+      </script>
+    `;
+
+    var open_new_tab = this.pgBrowser.get_preferences_for_module('browser').new_browser_tab_open;
+    if (open_new_tab && open_new_tab.includes('erd_tool')) {
+      var newWin = window.open('', '_blank');
+      newWin.document.write(erdToolForm);
+      newWin.document.title = panelTitle;
+      // Send the signal to runtime, so that proper zoom level will be set.
+      setTimeout(function() {
+        this.pgBrowser.send_signal_to_runtime('Runtime new window opened');
+      }, 500);
+    } else {
+      /* On successfully initialization find the dashboard panel,
+       * create new panel and add it to the dashboard panel.
+       */
+      var propertiesPanel = this.pgBrowser.docker.findPanels('properties');
+      var erdToolPanel = this.pgBrowser.docker.addPanel('frm_erdtool', wcDocker.DOCK.STACKED, propertiesPanel[0]);
+
+      // Set panel title and icon
+      setPanelTitle(erdToolPanel, 'Untitled');
+      erdToolPanel.icon('fa fa-sitemap');
+      erdToolPanel.focus();
+
+      // Register detach event.
+      registerDetachEvent(erdToolPanel);
+      var openErdToolURL = function(j) {
+        // add spinner element
+        let $spinner_el =
+          $(`<div class="pg-sp-container">
+                <div class="pg-sp-content">
+                    <div class="row">
+                        <div class="col-12 pg-sp-icon"></div>
+                    </div>
+                </div>
+            </div>`).appendTo($(j).data('embeddedFrame').$container);
+
+        let init_poller_id = setInterval(function() {
+          var frameInitialized = $(j).data('frameInitialized');
+          if (frameInitialized) {
+            clearInterval(init_poller_id);
+            var frame = $(j).data('embeddedFrame');
+            if (frame) {
+              frame.onLoaded(()=>{
+                $spinner_el.remove();
+              });
+              frame.openHTML(erdToolForm);
+            }
+          }
+        }, 100);
+      };
+
+      openErdToolURL(erdToolPanel);
+    }
+  }
+
+  getPanelUrl(transId, parentData, gen) {
+    let openUrl = url_for('erd.panel', {
+      trans_id: transId,
+    });
+
+    openUrl += `?sgid=${parentData.server_group._id}`
+      +`&sid=${parentData.server._id}`
+      +`&server_type=${parentData.server.server_type}`
+      +`&did=${parentData.database._id}`
+      +`&gen=${gen}`;
+
+    return openUrl;
+  }
+
+  setupPreferencesWorker() {
+    if (window.location == window.parent?.location) {
+      /* Sync the local preferences with the main window if in new tab */
+      setInterval(()=>{
+        if(pgWindow?.pgAdmin) {
+          if(this.pgAdmin.Browser.preference_version() < pgWindow.pgAdmin.Browser.preference_version()){
+            this.pgAdmin.Browser.preferences_cache = pgWindow.pgAdmin.Browser.preferences_cache;
+            this.pgAdmin.Browser.preference_version(pgWindow.pgAdmin.Browser.preference_version());
+            this.pgAdmin.Browser.triggerPreferencesChange('browser');
+            this.pgAdmin.Browser.triggerPreferencesChange('erd');
+          }
+        }
+      }, 1000);
+    }
+  }
+
+  loadComponent(container, params) {
+    let panel = null;
+
+    /* Mount the React ERD tool to the container */
+    _.each(pgWindow.pgAdmin.Browser.docker.findPanels('frm_erdtool'), function(p) {
+      if (p.isVisible()) {
+        panel = p;
+      }
+    });
+
+    this.setupPreferencesWorker();
+    ReactDOM.render(
+      <Theme>
+        <ModalProvider>
+          <ERDTool
+            params={params}
+            pgWindow={pgWindow}
+            pgAdmin={this.pgAdmin}
+            panel={panel}
+          />
+        </ModalProvider>
+      </Theme>,
+      container
+    );
+  }
+}
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/ERDConstants.js b/web/pgadmin/tools/erd/static/js/erd_tool/ERDConstants.js
new file mode 100644
index 000000000..323e08155
--- /dev/null
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/ERDConstants.js
@@ -0,0 +1,21 @@
+export const ERD_EVENTS = {
+  LOAD_DIAGRAM: 'LOAD_DIAGRAM',
+  SAVE_DIAGRAM: 'SAVE_DIAGRAM',
+  SHOW_SQL: 'SHOW_SQL',
+  DOWNLOAD_IMAGE: 'DOWNLOAD_IMAGE',
+  ADD_NODE: 'ADD_NODE',
+  EDIT_NODE: 'EDIT_NODE',
+  CLONE_NODE: 'CLONE_NODE',
+  DELETE_NODE: 'DELETE_NODE',
+  SHOW_NOTE: 'SHOW_NOTE',
+  ONE_TO_MANY: 'ONE_TO_MANY',
+  MANY_TO_MANY: 'MANY_TO_MANY',
+  AUTO_DISTRIBUTE: 'AUTO_DISTRIBUTE',
+  TOGGLE_DETAILS: 'TOGGLE_DETAILS',
+  ZOOM_FIT: 'ZOOM_FIT',
+  ZOOM_IN: 'ZOOM_IN',
+  ZOOM_OUT: 'ZOOM_OUT',
+  SINGLE_NODE_SELECTED: 'SINGLE_NODE_SELECTED',
+  ANY_ITEM_SELECTED: 'ANY_ITEM_SELECTED',
+  DIRTY: 'DIRTY',
+};
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/components/ConnectionBar.jsx b/web/pgadmin/tools/erd/static/js/erd_tool/components/ConnectionBar.jsx
new file mode 100644
index 000000000..7640a7e4f
--- /dev/null
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/components/ConnectionBar.jsx
@@ -0,0 +1,100 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React, { useMemo } from 'react';
+import gettext from 'sources/gettext';
+import PropTypes from 'prop-types';
+import { DefaultButton, PgButtonGroup, PgIconButton } from '../../../../../../static/js/components/Buttons';
+import { Box, makeStyles, Tooltip, CircularProgress } from '@material-ui/core';
+import { ConnectedIcon, DisonnectedIcon } from '../../../../../../static/js/components/ExternalIcon';
+
+export const STATUS = {
+  CONNECTED: 1,
+  DISCONNECTED: 2,
+  CONNECTING: 3,
+  FAILED: 4,
+};
+
+function ConnectionStatusIcon({status}) {
+  if(status == STATUS.CONNECTING) {
+    return <CircularProgress style={{height: '18px', width: '18px'}} />;
+  } else if(status == STATUS.CONNECTED || status == STATUS.FAILED) {
+    return <ConnectedIcon />;
+  } else {
+    return <DisonnectedIcon />;
+  }
+}
+
+ConnectionStatusIcon.propTypes = {
+  status: PropTypes.oneOf(Object.values(STATUS)).isRequired,
+};
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    padding: '2px 4px',
+    display: 'flex',
+    alignItems: 'center',
+    gap: '4px',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+    flexWrap: 'wrap',
+  },
+  connectionButton: {
+    display: 'flex',
+    width: '450px',
+    backgroundColor: theme.palette.default.main,
+    color: theme.palette.default.contrastText,
+    border: '1px solid ' + theme.palette.default.borderColor,
+    justifyContent: 'flex-start',
+  },
+}));
+
+/* The connection bar component */
+export default function ConnectionBar({status, bgcolor, fgcolor, title}) {
+  const classes = useStyles();
+  const connTitle = useMemo(()=>{
+    if(status == STATUS.CONNECTED) {
+      return gettext('Connected');
+    } else if(status == STATUS.CONNECTING) {
+      return gettext('Connecting');
+    } else if(status == STATUS.DISCONNECTED) {
+      return gettext('Disconnected');
+    } else if(status == STATUS.FAILED) {
+      return gettext('Failed');
+    }
+  }, [status]);
+  return (
+    <Box className={classes.root}>
+      <PgButtonGroup size="small">
+        <PgIconButton
+          title={connTitle}
+          icon={<ConnectionStatusIcon status={status} />}
+          data-test="btn-conn-status"
+        />
+        <DefaultButton className={classes.connectionButton} style={{backgroundColor: bgcolor, color: fgcolor}} data-test="btn-conn-title">
+          <Tooltip title={title}>
+            <Box display="flex" width="100%">
+              <Box textOverflow="ellipsis" overflow="hidden" marginRight="auto">
+                {status == STATUS.CONNECTING && (gettext('(Obtaining connection...)')+' ')}
+                {status == STATUS.FAILED && (gettext('(Connection failed)')+' ')}
+                {title}
+              </Box>
+            </Box>
+          </Tooltip>
+        </DefaultButton>
+      </PgButtonGroup>
+    </Box>
+  );
+}
+
+ConnectionBar.propTypes = {
+  status: PropTypes.oneOf(Object.values(STATUS)).isRequired,
+  bgcolor: PropTypes.string,
+  fgcolor: PropTypes.string,
+  title: PropTypes.string.isRequired,
+};
